<template>
  <div>
    <div class="padding">
      <div class="row">
        <!--<div class="columns four">-->
          <!--<label for="workType">Тип организации</label>-->
          <!--<multiselect id="workType"-->
                       <!--ref="workType"-->
                       <!--name="workType"-->
                       <!--v-model="workTypeStatus"-->
                       <!--:options="fieldWorkType"-->
                       <!--@input="getWorkTypeStatus"-->
                       <!--:vValidateRules="'required'"-->
                       <!--:searchable="false"-->
                       <!--:close-on-select="true"-->
                       <!--:value="typeOfOrganization"-->
                       <!--:show-labels="false"-->
                       <!--placeholder=""-->
                       <!--:preserve-search="true"-->
                       <!--label="title"-->
                       <!--track-by="id"-->
                       <!--v-validate="'required'"-->
                       <!--:class="getValidateClass('workType')"-->
                       <!--data-code="workTypeInvalidFormat, workTypeNotInAvailableRange"-->
          <!--&gt;-->
          <!--</multiselect>-->

          <!--<validate-message v-show="vErrors.has('workType')">-->
            <!--{{ vErrors.first('workType') }}-->
          <!--</validate-message>-->
        <!--</div>-->

        <div class="columns four text-overflow">
          <label for="workScope">Сфера деятельности организации</label>
          <multiselect id="workScope"
                       ref="workScope"
                       name="workScope"
                       v-model="workScopeStatus"
                       :options="fieldWorkScope"
                       @input="getWorkScopeStatus"
                       :vValidateRules="'required'"
                       :value="scopeOfOrganization"
                       :searchable="false"
                       :close-on-select="true"
                       :show-labels="false"
                       placeholder=""
                       :preserve-search="true"
                       label="title"
                       track-by="id"
                       v-validate="'required'"
                       :class="getValidateClass('workScope')"
                       data-code="workScopeInvalidFormat, workScopeNotInAvailableRange"
          >
          </multiselect>
          <validate-message v-show="vErrors.has('workScope')">
            {{ vErrors.first('workScope') }}
          </validate-message>
        </div>

        <div class="columns four text-overflow">
          <label for="workNumberOfEmployees">Кол-во сотрудников в компании</label>
          <multiselect id="workNumberOfEmployees"
                       name="workNumberOfEmployees"
                       v-model="workNumberOfEmployeesStatus"
                       :options="fieldWorkNumberOfEmployees"
                       @input="getWorkNumberOfEmployeesStatus"
                       :vValidateRules="'required'"
                       :value="numberEmployees"
                       :searchable="false"
                       :close-on-select="true"
                       :show-labels="false"
                       placeholder=""
                       :preserve-search="true"
                       label="title"
                       track-by="id"
                       v-validate="'required'"
                       :class="getValidateClass('workNumberOfEmployees')"
                       data-code="workNumberOfEmployeesInvalidFormat, workNumberOfEmployeesNotInAvailableRange"
          >
          </multiselect>
          <validate-message v-show="vErrors.has('workNumberOfEmployees')">
            {{ vErrors.first('workNumberOfEmployees') }}
          </validate-message>
        </div>

        <div class="columns four text-overflow">
          <label for="workPeriod">Стаж работы в данной компании</label>
          <multiselect v-model="workPeriodStatus"
                       :options="fieldWorkPeriod"
                       :searchable="false"
                       :close-on-select="true"
                       :show-labels="false"
                       placeholder=""
                       :value="workDatePeriod"
                       id="workPeriod"
                       ref="workPeriod"
                       :preserve-search="true"
                       label="title"
                       track-by="id"
                       @input="getWorkPeriodStatus"
                       :vValidateRules="'required'"
                       name="workPeriod"
                       v-validate="'required'"
                       :class="getValidateClass('workPeriod')"
                       data-code="workPeriodInvalidFormat, workPeriodNotInAvailableRange"
          >
          </multiselect>
          <validate-message v-show="vErrors.has('workPeriod')">
            {{ vErrors.first('workPeriod') }}
          </validate-message>
        </div>
      </div>
      <div class="row">
        <div class="columns four">
          <label for="workName">Название организации</label>
          <input type="text"
                 name="workName"
                 id="workName"
                 ref="workName"
                 :class="getValidateClass('workName')"
                 v-model="$user.workName"
                 v-validate="'required|min:4'"
                 autocomplete="off"
                 data-code="workNameTooShort, workNameTooLong"
          />

          <validate-message v-show="vErrors.has('workName')">
            {{ vErrors.first('workName') }}
          </validate-message>
        </div>
        <div class="columns four">
          <label for="workPhone">Телефон работодателя</label>
          <input type="tel"
                 name="workPhone"
                 id="workPhone"
                 ref="workPhone"
                 v-validate="'required|mobilePhone'"
                 :class="{error: vErrors.has('workPhone'), red: $errors.includes('workPhone')}"
                 v-model="$user.workPhone"
                 v-mask="'+7(###) ###-####'"
                 :guide="true"
                 placeholder="+7("
                 :keepCharPositions="true"
                 autocomplete="off"
                 data-code="workPhoneInvalidFormat"
          >

          <validate-message v-show="vErrors.has('workPhone') || $errors.includes('workPhone')">
            {{ vErrors.first('workPhone') }}
          </validate-message>
        </div>
      </div>






      <!--<div class="row">-->
        <!--<div class="columns four">-->
          <!--<label for="workPosition">Должность</label>-->
          <!--<input type="text"-->
                 <!--id="workPosition"-->
                 <!--ref="workPosition"-->
                 <!--name="workPosition"-->
                 <!--v-model="$user.workPosition"-->
                 <!--v-validate="'required|min:2'"-->
                 <!--:class="getValidateClass('workPosition')"-->
                 <!--autocomplete="off"-->
          <!--/>-->
          <!--<validate-message v-show="vErrors.has('workPosition')">-->
            <!--{{ vErrors.first('workPosition') }}-->
          <!--</validate-message>-->
        <!--</div>-->
      <!--</div>-->
    </div>
  </div>
</template>

<script>
  import UserGetter from '@/mixins/User/UserGetterMixin'
  import UserSetter from '@/mixins/User/UserSetterMixin'
  import UserErrorText from '@/mixins/User/UserErrorTextMixin'
  import GetValidateClass from '@/mixins/Validation/GetValidateClassMixin'
  import ValidateMessage from '@/components/Validators/ValidateMessage'
  import IndicatorRegistration from '@/mixins/IndicatorRegistration'
  import Multiselect from '@/UI/Multiselect'
  import { REQUIRED_FIELD, MIN_LENGHT } from '@/components/Validators/CustomVeeValidateMessage'
  import ErrorHandleMixin from '@/mixins/ErrorHandleMixin'
  import ChangeDataInProfile from '@/mixins/Profile/ChangeDataInProfile'

  export default {
    name: 'employee',
    mixins: [
      UserGetter,
      UserSetter,
      UserErrorText,
      GetValidateClass,
      IndicatorRegistration,
      ErrorHandleMixin,
      ChangeDataInProfile
    ],
    components: {
      ValidateMessage,
      Multiselect
    },
    data () {
      return {
        workTypeStatus: '',
        typeOfOrganization: '',
        scopeOfOrganization: '',
        workScopeStatus: '',
        numberEmployees: '',
        workNumberOfEmployeesStatus: '',
        workDatePeriod: '',
        workPeriodStatus: '',
        fieldWorkType: [
          {id: 1, title: 'Государственная'},
          {id: 2, title: 'Частная'}
        ],
        fieldWorkScope: [
          {id: 1, title: 'Добывающая промышленность'},
          {id: 2, title: 'Здравоохранение'},
          {id: 3, title: 'Информатика, телекоммуникации, ИТ'},
          {id: 4, title: 'Легкая и пищевая промышленность'},
          {id: 5, title: 'Машиностроение и металлообработка'},
          {id: 6, title: 'Наука и культура'},
          {id: 7, title: 'Образование'},
          {id: 8, title: 'Общественное питание (кафе, рестораны)'},
          {id: 9, title: 'Охранное предприятие (ЧОП, детективное агенство)'},
          {id: 10, title: 'Реклама, маркетинг, PR, СМИ'},
          {id: 11, title: 'Сельское хозяйство'},
          {id: 12, title: 'Силовые структуры (Вооруженные силы, МЧС, МВД и т.п.)'},
          {id: 13, title: 'Торговля оптовая, риэлторская деятельность'},
          {id: 14, title: 'Торговля розничная'},
          {id: 15, title: 'Туризм'},
          {id: 16, title: 'Федеральное и муниципальное управление'},
          {id: 17, title: 'Финансы, страхование, банковское дело'},
          {id: 18, title: 'Химия, парфюмерия, фармацевтика'},
          {id: 19, title: 'Юридические и нотариальные услуги'},
          {id: 20, title: 'Иное'}
        ],
        fieldWorkNumberOfEmployees: [
          {id: 1, title: '1-10'},
          {id: 2, title: '11-50'},
          {id: 3, title: '51-100'},
          {id: 4, title: '101-1000'},
          {id: 5, title: 'более 1000'}
        ],
        fieldWorkPeriod: [
          {id: 1, title: 'До 6 месяцев'},
          {id: 2, title: 'От 6 месяцев до года'},
          {id: 3, title: 'От 1 года до 5 лет'},
          {id: 4, title: 'Более 5 лет'}
        ]
      }
    },
    computed: {
      phoneWork: {
        get () {
          return this.$user.workPhone
        },
        set (val) {
          this.$user.workPhone = val
        }
      },
      workNameUser: {
        get () {
          return this.$user.workName
        },
        set (val) {
          this.$user.workName = val
        }
      },
      positionUser: {
        get () {
          return this.$user.workPosition
        },
        set (val) {
          this.$user.workPosition = val
        }
      }
    },
    created () {
      this.typeOfOrganization = this.workTypeStatus = this.fieldWorkType[this.$user.workType - 1];
      this.scopeOfOrganization = this.workScopeStatus = this.fieldWorkScope[this.$user.workScope - 1];
      this.numberEmployees = this.workNumberOfEmployeesStatus = this.fieldWorkNumberOfEmployees[this.$user.workNumberOfEmployees - 1];
      this.workDatePeriod = this.workPeriodStatus = this.fieldWorkPeriod[this.$user.workPeriod - 1];
    },
    methods: {
      getWorkTypeStatus (e) {
        this.$user.workType = e.id;
      },
      getWorkScopeStatus (e) {
        this.$user.workScope = e.id;
      },
      getWorkNumberOfEmployeesStatus (e) {
        this.$user.workNumberOfEmployees = e.id;
      },
      getWorkPeriodStatus (e) {
        this.$user.workPeriod = e.id;

      }
    },
    mounted () {
      this.$validator.localize(REQUIRED_FIELD)
      this.$validator.localize(MIN_LENGHT)
    },
    updated () {
      this.$user.validate.other.employer = Object.keys(this.$validator.flags).reduce((acc, item) => acc && this.$validator.flags[item].valid, true)
    }
  }
</script>

<style scoped lang="scss">
  ::-webkit-input-placeholder { /* Chrome/Opera/Safari */
    color: #DED3D3;
  }
  ::-moz-placeholder { /* Firefox 19+ */
    color: #DED3D3;
  }
  :-ms-input-placeholder { /* IE 10+ */
    color: #DED3D3;
  }
  :-moz-placeholder { /* Firefox 18- */
    color: #DED3D3;
  }

  .text-overflow {
    & label {
      text-overflow: ellipsis;
      width: 100%;
      overflow: hidden;
      white-space: nowrap;
    }
  }
</style>
